# -*-perl-*-

$SRCDIR   = $ENV{'SRCDIR'};
$BUILDDIR = $ENV{'BUILDDIR'};
$VERSION  = $ENV{'VERSION'};

print <<'EOF';
#! /bin/sh
#
# ozskel is a shell script that creates the files you need for
# managing/distributing a mozart contribution project
#
# It creates:
#	Makefile.in
#	configure.in
#	configure
#	aclocal.m4
#	config.sub
#	config.guess
#	ozinstall
#	Package.html
#	Package.mogul
#	i386-mingw32-oztool
#
# you should then extend edit and extend Makefile.in and configure.in
# to suit your needs.  The appropriate configure script is then created
# by invoking GNU autoconf.
EOF

print <<EOF;

MAKEFILE=
FORCE=
VERSION=$VERSION

EOF

print <<'EOF';
error() {
    echo "$1" 1>&2
    exit 1
}

for ARG
do
    case "$ARG" in
    -v) echo "ozskel version $VERSION"; exit 0 ;;
    -m) MAKEFILE=yes ;;
    -f) FORCE=yes ;;
    -*) error "unknown option $ARG" ;;
    * ) error "argument not understood \`$ARG'" ;;
    esac
done

EOF
    ;

sub packFile {
    my ($srcfile,$dstfile,$executable) = @_;
    if ( -e "${BUILDDIR}/${srcfile}" ) {
	open(F,"<${BUILDDIR}/${srcfile}")
	    || die "cannot open ${BUILDDIR}/${srcfile}: $!";
    }
    elsif ( -e "${SRCDIR}/${srcfile}" ) {
	open(F,"<${SRCDIR}/${srcfile}")
	    || die "cannot open ${SRCDIR}/${srcfile}: $!";
    }
    else {
	die "cannot find ${srcfile}";
    }
    my $text;
    { local $/ = undef; $text = <F>; }
    close(F);
    my $post;
    $post = "chmod +x ${dstfile}" if $executable;
     my $preif;
     my $postif;
     if ($dstfile ne 'Makefile.in') {
 	$preif = "if test -z \"\$MAKEFILE\"; then";
 	$postif= "fi";
     }
    print <<EOF;
$preif
if test -r ${dstfile}; then
    echo "Moving ${dstfile} to ${dstfile}.orig"
    mv -f ${dstfile} ${dstfile}.orig
fi
echo "Creating ${dstfile}"
cat >${dstfile} <<'OZSKEL__EOF'
$text
OZSKEL__EOF
$post
$postif
EOF
}

packFile('TemplateMakefile.in'   , 'Makefile.in'   , 0);
packFile('TemplateMakefile.vars' , 'Makefile.vars' , 0);
packFile('TemplateMakefile.rules', 'Makefile.rules', 0);
packFile('TemplateConfigure.in'  , 'configure.in'  , 0);
packFile('TemplateConfigure'     , 'configure'     , 1);
packFile('ozinstall'             , 'ozinstall'     , 1);
packFile('install-sh'            , 'install-sh'    , 1);
packFile('aclocal.m4'            , 'aclocal.m4'    , 0);
packFile('config.sub'            , 'config.sub'    , 1);
packFile('config.guess'          , 'config.guess'  , 1);
packFile('TemplatePage.html'     , 'Package.html'  , 0);
packFile('TemplateMogulPkg'      , 'Package.mogul' , 0);
packFile('i386-mingw32-oztool'	 , 'i386-mingw32-oztool', 1);
