AC_DEFUN(OZSKEL_PATH,[
  srcdir=`cd $srcdir 2> /dev/null && pwd`
  extrapath=$srcdir:`cd $srcdir/.. && pwd`:`cd $srcdir/../.. && pwd`:`cd $srcdir/../../.. && pwd`
  VAR_PATH=${srcdir}:${PATH}:${HOME}/.oz/bin:${OZHOME}/bin:/usr/local/OZSKEL/bin:/usr/local/oz/bin
  buildtop=`pwd`
  AC_SUBST(buildtop)
])

AC_DEFUN(OZSKEL_PATH_PROG, [
  if test -z "$OZSKEL_cv_$1"; then
    dummy_PWD=`pwd | sed 's/\//\\\\\//g'`
    dummy_PATH=`echo $VAR_PATH | sed -e 's/:://g'`
    dummy_PATH=`echo $dummy_PATH | sed -e "s/^\.:/$dummy_PWD:/g"`
    dummy_PATH=`echo $dummy_PATH | sed -e "s/^\.\//$dummy_PWD\//g"`
    dummy_PATH=`echo $dummy_PATH | sed -e "s/:\.\$/:$dummy_PWD/g"`
    dummy_PATH=`echo $dummy_PATH | sed -e "s/:\.:/:$dummy_PWD:/g"`
    dummy_PATH=`echo $dummy_PATH | sed -e "s/:.\//:$dummy_PWD\//g"`
    OZSKEL_for="$dummy_PATH"
    AC_PATH_PROGS($1,$2.exe $2,,$OZSKEL_for)
    case "$host_os" in
      cygwin32) ;;
      *) $1=`echo $$1 | sed -e "s|//|/|g"`;;
    esac
    if test ! -n "$$1"
    then
	$1=undefined
	ifelse([$3],[],[AC_MSG_ERROR([$2 not found])],$3)
    fi
    OZSKEL_cv_$1=$$1
  else
    AC_CACHE_CHECK([for $2],OZSKEL_cv_$1,true)
    $1=$OZSKEL_cv_$1
  fi
  AC_SUBST($1)])

dnl this assumes that VAR_OZE is set to the full path of the
dnl ozengine.  OZHOME is derived from it.
AC_DEFUN(OZSKEL_OZHOME,[
  if test "${OZHOME:-NONE}" = NONE; then
changequote(<,>)
    OZHOME=`expr "${VAR_OZE}" : '\(.*\)/[^/]*/[^/]*$' || echo "."`
changequote([,])
  fi
  AC_SUBST(OZHOME)
])

AC_DEFUN(OZSKEL_INSTALL,[
  if test -z "$OZSKEL_cv_INSTALL"; then
    AC_PATH_PROG(OZSKEL_cv_OZINSTALL,ozinstall,NONE,${extrapath}:${VAR_PATH})
    if test "$OZSKEL_cv_OZINSTALL" = NONE; then
      AC_MSG_ERROR([ozinstall not found])
    fi
  else
    AC_CACHE_CHECK([for ozinstall],OZSKEL_cv_OZINSTALL,true)
  fi
  VAR_OZINSTALL=$OZSKEL_cv_OZINSTALL
  AC_SUBST(VAR_OZINSTALL)
])

AC_DEFUN(OZSKEL_COMPRESS,[
  if test -z "$OZSKEL_cv_COMPRESS"; then
    AC_PATH_PROGS(OZSKEL_cv_COMPRESS,gzip compress,compress,${VAR_PATH})
  else
    AC_CACHE_CHECK([for gzip or compress],OZSKEL_cv_COMPRESS,true)
  fi
  VAR_COMPRESS=$OZSKEL_cv_COMPRESS
  AC_SUBST(VAR_COMPRESS)
])

dnl *****************************************************************
dnl windows cross compilation
dnl *****************************************************************

AC_DEFUN(OZSKEL_WINDLLDIR,[
  AC_ARG_WITH(windlldir,
    [--with-windlldir=DIR],
    OZSKEL_cv_WINDLLDIR=$with_windlldir)
  : ${VAR_WINDLLDIR:=$OZSKEL_cv_WINDLLDIR}
])

AC_DEFUN(OZSKEL_OZTOOL,[
  AC_SUBST(VAR_WINDLLDIR)
  OZSKEL_PATH_PROG(VAR_OZTOOL_HOST,oztool)
dnl we don't actively support cross-compilation anymore
dnl  case "$target" in
dnl    NONE)
        VAR_OZTOOL="$VAR_OZTOOL_HOST"
dnl	;;
dnl    i386-mingw32)
dnl	AC_MSG_RESULT(cross compiling for windows)
dnl	VAR_OZTOOL="sh ${target}-oztool"
dnl	OZSKEL_WINDLLDIR
dnl	;;
dnl    *)
dnl	AC_MSG_ERROR("only known cross-compile target is i386-mingw32")
dnl	;;
dnl  esac
  AC_SUBST(VAR_OZTOOL)
])

AC_DEFUN(OZSKEL_INIT,[
  AC_CANONICAL_HOST
  AC_PROG_MAKE_SET
  OZSKEL_PATH
  OZSKEL_INSTALL
  OZSKEL_COMPRESS
  OZSKEL_OZTOOL
  OZSKEL_PATH_PROG(VAR_OZC,ozc)
  OZSKEL_PATH_PROG(VAR_OZL,ozl)
  OZSKEL_PATH_PROG(VAR_OZE,ozengine)
  OZSKEL_PATH_PROG(VAR_OZH,ozh,VAR_OZH=x-ozlib://OZSKEL/ozh)
  OZSKEL_PATH_PROG(VAR_ZIP,zip,VAR_ZIP=zip)
  OZSKEL_OZHOME
])

dnl copied from recent mozart/aclocal.m4
dnl ------------------------------------------------------------------
dnl OZ_CHECK_VERSION(OK,GOT,WANT)
dnl
dnl GOT and WANT consist of integers separated by single periods, e.g.
dnl 23.1 or 3.5.7, and OK is set to yes or no according to whether
dnl GOT >= WANT with respect to the obvious ordering.  To accomodate
dnl such program as perl, we also permit `_' and `-' instead of `.'
dnl
dnl for example
dnl	OZ_CHECK_VERSION(OK,$VERSION,2.5.4)
dnl sets OK to yes or no, according to whether $VERSION is greater
dnl than 2.5.4
dnl
dnl Note that we now support having one letter at the end: this
dnl interpreted as a "beta" version.  Thus 1.3.23c is less that
dnl 1.3.23, but more than 1.3.23a.
dnl
dnl `set $oz_tmp_got DONE' results in the component integers being
dnl assigned to positional parameters $1, $2 etc... DONE marks the
dnl of this sequence. The for loop goes through what we `want' but
dnl also through what correspondingly we `got' through positional
dnl parameter $1.  the `shift' at the end of the loop moves left
dnl all positional parameters, thus bringing the next thing we `got'
dnl into $1.
dnl
dnl Note that if GOT is empty the test succeeds (so don't do it)
dnl ------------------------------------------------------------------

AC_DEFUN(OZ_PREPARE_VERSION,[
  oz_tmp="$[$1]"
changequote(<,>)
  oz_tmp=`echo $oz_tmp | sed -e 's/[a-z]/.\0/'`
  oz_tmp=`echo $oz_tmp | sed -e 's/[._-]/ /g'`
changequote([,])
  [$1]=$oz_tmp])

AC_DEFUN(OZ_CHECK_VERSION,[
  oz_tmp_got="[$2]"
  oz_tmp_want="[$3]"
  OZ_PREPARE_VERSION(oz_tmp_got)
  OZ_PREPARE_VERSION(oz_tmp_want)
  set $oz_tmp_got DONE
  oz_tmp__ok=yes
  for oz_tmp_cur in $oz_tmp_want; do
    case $oz_tmp_cur in
      DONE)
         case $[1] in
           [a-z]) oz_tmp__ok=no;;
           *);;
         esac
         break
         ;;
      [a-z])
         case $[1] in
           DONE) break;;
           [a-z])
              if test `expr $oz_tmp_cur '<=' $[1]` -eq 0; then
                oz_tmp__ok=no
                break
              fi
           ;;
           *) break
           ;;
         esac
         ;;
      *)
         case $[1] in
           DONE) oz_tmp__ok=no
             break
             ;;
           [a-z]) oz_tmp__ok=no
             break
             ;;
           *) if test "$oz_tmp_cur" -lt "$[1]"; then
                break
              elif test "$oz_tmp_cur" -gt "$[1]"; then
                oz_tmp__ok=no
                break
              fi
           ;;
         esac
         ;;
    esac
    [shift]
  done
  [$1]=$oz_tmp__ok])

dnl ------------------------------------------------------------------
dnl OZ_PROG_VERSION_CHECK(VAR,PROG,VERSION [,HOW])
dnl
dnl gets the --version of PROG and compares it to VERSION
dnl sets VAR to yes or no accordingly. HOW is the command to execute
dnl to get the text containing the string `version XXXX' where XXXX
dnl is the version number.  If HOW is not supplied we use the
dnl --version option.
dnl ------------------------------------------------------------------

AC_DEFUN(OZ_PROG_VERSION_CHECK,[
  AC_MSG_CHECKING([$2 version is at least $3])
  [$1]=no
  if oz_tmp_version1=`ifelse([$4],[],[$2 --version],[$4]) 2>/dev/null`; then
    # first we try to locate the string "version"
    oz_tmp_version2=`echo "${oz_tmp_version1}" | tr '\012' ' '`
changequote(<,>)
    oz_tmp_version=`expr "${oz_tmp_version2}" : '.*version \([0-9._-]*[a-z]\{0,1\}\)'`
    # if that failed: we look at the end of the first line
    if test -z "$oz_tmp_version"; then
      oz_tmp_IFS="$IFS"
      IFS='
'
      for oz_tmp_version3 in ${oz_tmp_version1}; do
        oz_tmp_version=`expr "${oz_tmp_version3}" : '.* \([0-9._-]*[a-z]\{0,1\}\)$'`
	# else try to match the entire first line
	if test -z "$oz_tmp_version"; then
	  oz_tmp_version=`expr "${oz_tmp_version3}" : '\([0-9._-]*[a-z]\{0,1\}\)$'`
	fi
	break
      done
      IFS="$oz_tmp_IFS"
    fi
changequote([,])
    if test -n "$oz_tmp_version"; then
      OZ_CHECK_VERSION([$1],$oz_tmp_version,[$3])
    fi
  fi
  if test -z "$oz_tmp_version"; then
    AC_MSG_RESULT([no (cannot find version)])
  elif test $[$1] = no; then
    AC_MSG_RESULT([no])
  else
    AC_MSG_RESULT([yes ($oz_tmp_version)])
  fi])
